## ros-foxy-rcpputils 1.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rcpputils)

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_ros REQUIRED)
find_package(rcutils REQUIRED)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()
# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(NOT WIN32)
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

include_directories(include)

ament_export_include_directories(include)

add_library(${PROJECT_NAME}
  src/asserts.cpp
  src/find_library.cpp
  src/shared_library.cpp)
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")
if(WIN32)
  target_compile_definitions(${PROJECT_NAME}
    PRIVATE "RCPPUTILS_BUILDING_LIBRARY")
endif()
ament_target_dependencies(${PROJECT_NAME} rcutils)
ament_export_libraries(${PROJECT_NAME})
ament_export_targets(${PROJECT_NAME})
ament_export_dependencies(rcutils)

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_lint_auto REQUIRED)

  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wthread-safety -Werror)
  endif()

  ament_lint_auto_find_test_dependencies()

  ament_add_gtest(test_asserts_ndebug test/test_asserts.cpp)
  target_link_libraries(test_asserts_ndebug ${PROJECT_NAME})

  if(TARGET test_asserts_ndebug)
    target_compile_definitions(test_asserts_ndebug PUBLIC NDEBUG)
  endif()

  ament_add_gtest(test_asserts_debug test/test_asserts.cpp)
  target_link_libraries(test_asserts_debug ${PROJECT_NAME})

  ament_add_gtest(test_thread_safety_annotations test/test_thread_safety_annotations.cpp)

  ament_add_gtest(test_join test/test_join.cpp)

  ament_add_gtest(test_get_env test/test_get_env.cpp
    ENV
      EMPTY_TEST=
      NORMAL_TEST=foo
  )
  ament_target_dependencies(test_get_env rcutils)

  ament_add_gtest(test_scope_exit test/test_scope_exit.cpp)
  target_link_libraries(test_scope_exit ${PROJECT_NAME})

  ament_add_gtest(test_split test/test_split.cpp)

  ament_add_gtest(test_filesystem_helper test/test_filesystem_helper.cpp
    ENV
      EXPECTED_WORKING_DIRECTORY=$<SHELL_PATH:${CMAKE_CURRENT_BINARY_DIR}>
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  ament_target_dependencies(test_filesystem_helper rcutils)

  ament_add_gtest(test_find_and_replace test/test_find_and_replace.cpp)

  ament_add_gtest(test_pointer_traits test/test_pointer_traits.cpp)

  ament_add_gtest(test_process test/test_process.cpp)
  ament_target_dependencies(test_process rcutils)

  set(append_library_dirs "$<TARGET_FILE_DIR:${PROJECT_NAME}>")

  ament_add_gtest(test_shared_library test/test_shared_library.cpp
    APPEND_LIBRARY_DIRS "${append_library_dirs}"
  )

  if(TARGET test_shared_library)
    add_library(dummy_shared_library test/dummy_shared_library/dummy_shared_library.c)
    if(WIN32)
      # Causes the visibility macros to use dllexport rather than dllimport
      # which is appropriate when building the dll but not consuming it.
      target_compile_definitions(dummy_shared_library PRIVATE "DUMMY_SHARED_LIBRARY_BUILDING_DLL")
    endif()
    target_link_libraries(test_shared_library ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_endian test/test_endian.cpp)

  add_library(test_library SHARED test/test_library.cpp)
  ament_add_gtest(test_find_library test/test_find_library.cpp)
  target_link_libraries(test_find_library ${PROJECT_NAME} test_library)
  set_tests_properties(test_find_library PROPERTIES
    ENVIRONMENT
      "_TEST_LIBRARY_DIR=$<TARGET_FILE_DIR:test_library>;_TEST_LIBRARY=$<TARGET_FILE:test_library>")

  ament_add_gtest(test_clamp test/test_clamp.cpp)
endif()

ament_package()

install(
  DIRECTORY include/
  DESTINATION include)
install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== debian/changelog ===
ros-foxy-rcpputils (1.3.2-1focal) focal; urgency=high

  * Add stream operator for paths to make it easier to log (#120 <https://github.com/ros2/rcpputils/issues/120>) (#121 <https://github.com/ros2/rcpputils/issues/121>)
  * Removed Github Actions (#105 <https://github.com/ros2/rcpputils/issues/105>) (#106 <https://github.com/ros2/rcpputils/issues/106>)
  * Updating quality declaration links (ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#131 <https://github.com/ros2/rcpputils/issues/131>)
  * Update to quality level 1 (#115 <https://github.com/ros2/rcpputils/issues/115>)
  * Update maintainer list for Foxy (#109 <https://github.com/ros2/rcpputils/issues/109>)
  * Contributors: Alejandro Hernández Cordero, Emerson Knapp, Michael Jeronimo, Stephen Brawner, shonigmann

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 31 Aug 2021 07:00:00 -0000

ros-foxy-rcpputils (1.3.1-1focal) focal; urgency=high

  * Add scope_exit helper. (#78 <https://github.com/ros2/rcpputils//issues/78>) (#103 <https://github.com/ros2/rcpputils//issues/103>)
  * Contributors: Alejandro Hernández Cordero, Michel Hidalgo

 -- Emerson Knapp <eknapp@amazon.com>  Fri, 09 Oct 2020 07:00:00 -0000

ros-foxy-rcpputils (1.3.0-1focal) focal; urgency=high

  * Removed doxygen warnings (#86 <https://github.com/ros2/rcpputils/issues/86>) (#90 <https://github.com/ros2/rcpputils/issues/90>)
  * Add clamp header (#85 <https://github.com/ros2/rcpputils/issues/85>) (#88 <https://github.com/ros2/rcpputils/issues/88>)
  * Add remove_all to remove non-empty directories… (#80 <https://github.com/ros2/rcpputils/issues/80>)
  * Contributors: Alejandro Hernández Cordero, Hunter L. Allen, Karsten Knese, Victor Lopez

 -- Emerson Knapp <eknapp@amazon.com>  Tue, 21 Jul 2020 07:00:00 -0000

ros-foxy-rcpputils (1.1.0-1focal) focal; urgency=high

  * Fix parent_path() for empty paths and paths of length one (#73 <https://github.com/ros2/rcpputils/issues/73>)
  * Add get_executable_name() function (#70 <https://github.com/ros2/rcpputils/issues/70>)
  * Address memory leak in remove pointer test (#72 <https://github.com/ros2/rcpputils/issues/72>)
  * Add current_path to filesystem_helpers (#63 <https://github.com/ros2/rcpputils/issues/63>)
  * Align path combine behavior with C++17 (#68 <https://github.com/ros2/rcpputils/issues/68>)
  * Update quality declaration to QL 2 (#71 <https://github.com/ros2/rcpputils/issues/71>)
  * Contributors: Jacob Perron, Scott K Logan, Stephen Brawner

 -- Emerson Knapp <eknapp@amazon.com>  Mon, 22 Jun 2020 07:00:00 -0000

ros-foxy-rcpputils (1.0.1-1focal) focal; urgency=high

  * Include stdexcept in get_env.hpp (#69 <https://github.com/ros2/rcpputils/issues/69>)
  * Update quality declaration for version stability (#66 <https://github.com/ros2/rcpputils/issues/66>)
  * Handle empty paths in is_absolute (#67 <https://github.com/ros2/rcpputils/issues/67>)
  * Add Security Vulnerability Policy pointing to REP-2006 (#65 <https://github.com/ros2/rcpputils/issues/65>)
  * Contributors: Chris Lalancette, Scott K Logan, Steven! Ragnarök

 -- Emerson Knapp <eknapp@amazon.com>  Wed, 03 Jun 2020 07:00:00 -0000

ros-foxy-rcpputils (1.0.0-1focal) focal; urgency=high

  * Remove mention of random file from temporary_directory_path doc (#64 <https://github.com/ros2/rcpputils/issues/64>)
  * Contributors: Scott K Logan

 -- Emerson Knapp <eknapp@amazon.com>  Tue, 26 May 2020 07:00:00 -0000

ros-foxy-rcpputils (0.3.1-1focal) focal; urgency=high

  * Fix Action CI by using released upload-artifact instead of master (#61 <https://github.com/ros2/rcpputils/issues/61>)
  * Quality declaration (#47 <https://github.com/ros2/rcpputils/issues/47>)
  * Contributors: Emerson Knapp, brawner

 -- Emerson Knapp <eknapp@amazon.com>  Fri, 08 May 2020 07:00:00 -0000

ros-foxy-rcpputils (0.3.0-1focal) focal; urgency=high

  * Added shared library to feature list (#58 <https://github.com/ros2/rcpputils/issues/58>)
  * export targets in a addition to include directories / libraries (#57 <https://github.com/ros2/rcpputils/issues/57>)
  * remove pointer for smart pointer (#56 <https://github.com/ros2/rcpputils/issues/56>)
  * Added shared library class description to readme (#53 <https://github.com/ros2/rcpputils/issues/53>)
  * Increased shared library tests (#51 <https://github.com/ros2/rcpputils/issues/51>)
  * Removed duplicated split function (#54 <https://github.com/ros2/rcpputils/issues/54>)
  * Exposed get_env_var (#55 <https://github.com/ros2/rcpputils/issues/55>)
  * Added debug version for library names (#52 <https://github.com/ros2/rcpputils/issues/52>)
  * Added unload_library method to shared_library (#50 <https://github.com/ros2/rcpputils/issues/50>)
  * Included abstraction for rcutils::shared_library (#49 <https://github.com/ros2/rcpputils/issues/49>)
  * Add more documentation and include doxyfile (#46 <https://github.com/ros2/rcpputils/issues/46>)
  * Update README.md with license and build badges. (#45 <https://github.com/ros2/rcpputils/issues/45>)
  * Update README to mention assertion helper functions (#43 <https://github.com/ros2/rcpputils/issues/43>)
  * Add rcpputils::fs::file_size and rcpputils::fs::is_directory (#41 <https://github.com/ros2/rcpputils/issues/41>)
  * Make assert functions accept an optional string. (#42 <https://github.com/ros2/rcpputils/issues/42>)
  * Add functions for C++ assertions (#31 <https://github.com/ros2/rcpputils/issues/31>)
  * remove reference for pointer traits (#38 <https://github.com/ros2/rcpputils/issues/38>)
  * code style only: wrap after open parenthesis if not in one line (#36 <https://github.com/ros2/rcpputils/issues/36>)
  * Bug fixes for rcpputils::fs API (#35 <https://github.com/ros2/rcpputils/issues/35>)
    * Ensure rcpputils::fs::create_directories works with absolute paths.
    * Implement temp_directory_path() for testing purposes.
    * Fix rcpputils::fs::path::parent_path() method.


=== debian/control ===
Source: ros-foxy-rcpputils
Section: misc
Priority: optional
Maintainer: Chris Lalancette <clalancette@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-gtest, ros-foxy-ament-cmake-ros, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-rcutils, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rcpputils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-rcutils, ros-foxy-ros-workspace
Description: Package containing utility code for C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rcpputils//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
